package body ordered_collection_adt is
    
--    function new_ordered_collection return ordered_collection is
        
--        variable result : ordered_collection_ptr
--            := new ordered_collection_object;
        
--    begin
--        result.next_element := result;
--        result.prev_element := result;
--        return ordered_collection(result);
--    end function new_ordered_collection;


    procedure new_ordered_collection ( c : out ordered_collection ) is

        variable result : ordered_collection_ptr
            := new ordered_collection_object;
        
    begin
        result.next_element := result;
        result.prev_element := result;
        c := ordered_collection(result);
    end function new_ordered_collection;


    procedure insert ( c : inout ordered_collection;
                       e : in element_type ) is
        
        variable current_element : ordered_collection_ptr
            := ordered_collection_ptr(c).next_element;
        variable new_element : ordered_collection_ptr;
        
        variable next_element, prev_element : ordered_collection_ptr;

    begin
        while current_element /= ordered_collection_ptr(c)
            and key_of(current_element.element) < key_of(e) loop
            current_element := current_element.next_element;
        end loop;
        -- insert new element before current_element
        new_element := new ordered_collection_object'(
                               element => e,
                               next_element => current_element,
                               prev_element => current_element.prev_element );
--        new_element.next_element.prev_element := new_element;
--        new_element.prev_element.next_element := new_element;
        next_element := new_element.next_element;
        next_element.prev_element := new_element;
        prev_element := new_element.prev_element;
        prev_element.next_element := new_element;
    end procedure insert;


    procedure traverse
        generic ( procedure action ( element : in element_type ) )
        ( c : in ordered_collection ) is
        
        variable current_element : ordered_collection_ptr
            := ordered_collection_ptr(c).next_element;
        
    begin
        while current_element /= ordered_collection_ptr(c) loop
            action ( current_element.element );
            current_element := current_element.next_element;
        end loop;
    end procedure traverse;
    
end package body ordered_collection_adt;
