package instructions is

    use std.textio.all;

    type opcode_type is ( nop, load, store, add, sub, trap, jal, jr, rfe );

    type register_number is new integer range 0 to 31;

    type protection_mode is ( user, supervisor );

    type instruction is
        tagged record
            opcode : opcode_type;
        end record instruction;
    
    function privileged ( instr : instruction;
                          mode : protection_mode ) return boolean;
    
    procedure disassemble ( instr : instruction;  L : inout line );

    procedure disassemble_reg ( reg : register_number;  L : inout line );

    function read_register ( reg : register_number ) return integer;

end package instructions;
