architecture behavioral of test_bench is

    use std.textio.all;
    
    use work.instructions.all;

    use work.memory_instructions.all;

    use work.load_instructions.all;

    signal fetched_instruction : instruction'class;
                     
begin

    tester : process is

        variable current_instruction : instruction
            := instruction'(opcode => nop);

        variable L : line;

        variable potential_load : load_instruction;
        variable potential_memory : memory_instruction;

        constant nop_instruction : instruction := instruction'(opcode => nop);

        variable current_mode : protection_mode := user;

        type exception_type is ( privileged_instruction, trap );

        procedure raise_exception ( exception : exception_type ) is
        begin
            null;
        end procedure raise_exception;

        procedure execute ( instr : instruction'class ) is
            variable L : line;
        begin
            if privileged ( instr, current_mode ) then
		raise_exception ( privileged_instruction );
            else
		disassemble ( instr, L );
            end if;
        end procedure execute;

    begin
        disassemble ( fetched_instruction, L );
--        potential_load := load_instruction'( nop_instruction with
--                                             base => 0, offset => 0,
--                                             destination => 0 );
        potential_memory := memory_instruction'( nop_instruction with
                                                 base => 0, offset => 0 );
        potential_load := load_instruction'( potential_memory with
                                             destination => 0 );

        wait;
    end process tester;

end architecture behavioral;
