architecture behavioral of vision_system is

    type processing_step is ( raw, filtered );

    type image_token is
        record
            token_id : integer;
            degree_of_processing : processing_step;
        end record image_token;
	
    type image_channel is channel of image_token;
    
    channel source_image, intermediate_image : image_channel;

begin

    camera_controller : process is
	variable acquired_image : image_token;
    begin
	acquired_image := (0, raw);	-- acquire next image
	send acquired_image to source_image;
    end process camera_controller;
    
    first_filter : process is
	variable raw_image, filtered_image : image_token;
    begin
	receive raw_image from source_image;
	filtered_image := raw_image; 		-- filter the raw image
        filtered_image.degree_of_processing := filtered;
	send filtered_image to intermediate_image;
    end process first_filter;

end architecture behavioral;
